Attribute VB_Name = "Code"
Option Explicit

Public Declare Function Inp Lib "inpout32.dll" Alias "Inp32" (ByVal PortAddress As Integer) As Integer
Public Declare Sub Out Lib "inpout32.dll" Alias "Out32" (ByVal PortAddress As Integer, ByVal Value As Integer)
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Global Const APPNAME = "SBTC-PC-Datenkommunikation"

Global Const MAXMEMSIZE = 1024
Global intByteArray%(MAXMEMSIZE)

Global Const INBUFSIZE = 5
Global intInBuf%(INBUFSIZE)
Global intBufCnt%, intRXBytes%
Global intGChar%

Global intAirPressure%
Global intN2_1%, intN2_2%, intN2_3%, intN2_4%
Global intHe_1%, intHe_2%, intHe_3%, intHe_4%
Global intConsFactor%
Global intMaxPpO2%
Global intADG%

Global intNDives%
Global intDiveMinutes%
Global intMaxDepth%

Global intConstppO2%
Global intCabinPressure%
Global intHeightSeaLevel%

Global intSoftwareVer_Major%, intSoftwareVer_Minor%, intSoftwareVer_Rev%

Global intComPort%, intComDelay%
Global intErrors%, intMaxTolErrors%
Global strSendCode$

Global intTimeUp%
Global intAbortStatus%
Global intIsTransfer%

Global intPicNum%


Function CheckCRC%(intLastByte%)

  Dim T1%
  Dim intX%
    
  intX = 0
  
  For T1 = 0 To intLastByte
    intX = intX Xor intInBuf(T1)
  Next T1
  
  CheckCRC = intX
    
End Function
Sub DecodeDive(intStartByte%)
 
  Dim T1%, T2%
  Dim intTi%, intTiTotal%, intTiCnt%
  Dim strFileName$
  Dim intSBTCDiveNumber%
  Dim intRecInterval%
  Dim intSurfInterval%
  Dim intAirTemp%
  Dim strDeko$
  Dim Depth%, PCnt%
  
  On Error GoTo Err_DecodeDive
  
  frmMain.cdgMain.DialogTitle = "Tauchprofil speichern unter..."
  frmMain.cdgMain.Flags = cdlOFNExplorer + cdlOFNHideReadOnly + cdlOFNOverwritePrompt + cdlOFNPathMustExist
  frmMain.cdgMain.Filter = "Tauchprofile VD 2.x (*.vdp)|*.vdp|"
  frmMain.cdgMain.filename = "*.vdp"
  frmMain.cdgMain.FilterIndex = 1
  frmMain.cdgMain.ShowSave
  
  strFileName = frmMain.cdgMain.filename
    
  Open strFileName For Output As #1
  Print #1, "Depth   t.delta t.total N2%     He%"
    
  intSurfInterval = intByteArray(intStartByte + 1) + intByteArray(intStartByte + 2) * 256
  intAirTemp = intByteArray(intStartByte + 3)
  intRecInterval = intByteArray(intStartByte + 4)
  
  If intByteArray(intStartByte + 5) = 129 Then
  
    T1 = intStartByte + 5
    intTiTotal = 0
    PCnt = 0
    Depth = 0
        
    While intByteArray(T1) <> 130
      
      Select Case intByteArray(T1)
        Case 122: Print #1, "; SLOW " & Format(intTiTotal)
        Case 123: Print #1, "; CEIL " & Format(intTiTotal)
        Case 124: Print #1, "; PPO2 " & Format(intTiTotal)
        Case 125: Print #1, "; ASC " & Format(intTiTotal)
        Case 126: T1 = T1 + 1
                  Print #1, "; GAS" & Format(intByteArray(T1)) & " " & Format(intTiTotal)
        Case 127: Print #1, "; SURF " & Format(intTiTotal)
        Case Else:
                   If intByteArray(T1) > 138 Then
                     Depth = Depth + (256 - intByteArray(T1)) * 0.1
                   End If
                   If intByteArray(T1) < 122 Then
                     Depth = Depth - intByteArray(T1) * 0.1
                   End If
                   PCnt = PCnt + 1
                   If PCnt >= 3 Then
                     intTiTotal = intTiTotal + 1
                     Print #1, Format(Depth) & Chr(9) & Format(1) & Chr(9) & Format(intTiTotal) & Chr(9) & "78" & Chr(9) & "0"
                     PCnt = 0
                   End If
                   
      End Select
      T1 = T1 + 1
    Wend
  End If
    
  Print #1, "# END OF PROFILE #"
    
  Print #1, "Dauer: " & Format(intByteArray(T1 + 1) + intByteArray(T1 + 2) * 256) & "min."
  Print #1, "Maximale Tiefe: " & Format((intByteArray(T1 + 3) + 256 * intByteArray(T1 + 4)) / 10) & "m"
  Print #1, "Niedrigste Temperatur: " & intByteArray(T1 + 5) & " C"
  Print #1, "Temperatur auf maximaler Tiefe: " & Format(intByteArray(T1 + 6)) & "C"
  Print #1, "Aufzeichnungsintervall: " & Format(intRecInterval) & "s"
  Print #1, "Oberflchenpause vor dem TG: " & Format(intSurfInterval) & "min."
  Print #1, "Lufttemperatur vor TG: " & intAirTemp & "C"
  intSBTCDiveNumber = intByteArray(T1 + 8)
  Print #1, "TG-Nr. im SBTC-Log: " & Format(intSBTCDiveNumber)
  
  strDeko = ""
  If intByteArray(T1 + 6) = 203 Then
    For T2 = 1 To 10
      If intByteArray(T1 + 8) > 0 Then
        strDeko = strDeko & " " & Format(T2 * 3) & "m:" & intByteArray(T1 + 8) & "min.  "
      End If
      T1 = T1 + 1
    Next T2
  End If
  
  Print #1, "Bemerkungen: Dekostufen: " & strDeko
  
  Close #1
    
  Call Msg("Datei gespeichert: " & strFileName)
  
  Exit Sub
  
Err_DecodeDive:
  
  Call MsgBox("Fehler: " & Error(Err), vbOKOnly + vbCritical, APPNAME)
  
  Exit Sub
  
End Sub
Sub InitByteArray()

  Dim T1%
   
  For T1 = 1 To MAXMEMSIZE
    intByteArray(T1) = 0
  Next
   
End Sub
Sub InitInBuffer()

  Dim T1%
   
  For T1 = 1 To INBUFSIZE
    intInBuf(T1) = 0
  Next
  intBufCnt = 0
  intRXBytes = 0

  strSendCode = ""
End Sub
'Make Decimal Number
Function MDN$(strS$)

  Dim T1%, strX$
  
  For T1 = 1 To Len(strS)
    If Mid$(strS, T1, 1) = "," Then
      strX = strX & "."
    Else
      strX = strX & Mid$(strS, T1, 1)
    End If
  Next T1
  
  MDN = strX
  
End Function

Sub Msg(strMsg$)

  frmMain.lstIn.AddItem strMsg
  frmMain.lstIn.ListIndex = frmMain.lstIn.ListCount - 1
  
End Sub

Function RegistryRead$(strSect$, strKey$)
   
  RegistryRead = GetSetting(APPNAME, strSect, strKey, "")
  
End Function
Sub RegistryWrite(strSection$, strKey$, strEntry$)

  SaveSetting APPNAME, strSection, strKey, strEntry
  
End Sub

Function Read_SBTC_EEPROM%(intByte0%, intByte1%, strFileName$)
  
  Dim T1%, T2%
  Dim intByteCnt%
  Dim intAdrLo%, intAdrHi%
    
  Call InitByteArray
    
  Call Msg("Lese Speicher von Byte " & Format(intByte0) & " bis " & Format(intByte1))
  
  Call ShowTransfer(1)
  intIsTransfer = 1
  
  Call MenuEnable(0)
  
  intByteCnt = 0
  intErrors = 0
  intAbortStatus = 0
  frmMain.pgbMain.Min = 0
  frmMain.pgbMain.Max = intByte1 + 1
    
  T1 = intByte0
  Do While (T1 < intByte1)
        
    'Adresse berechnen
    intAdrHi = Int(T1 / 256)
    intAdrLo = T1 - intAdrHi * 256
    
    'Puffer initialisieren
    Call InitInBuffer
        
    'Befehl absenden
    strSendCode = Chr(100) & Chr(intAdrLo) & Chr(intAdrHi)
    frmMain.comSBTC.Output = strSendCode
        
    'Flag auf 0 und Timer starten
    intTimeUp = 0
    frmMain.timWait.Enabled = True
    While intTimeUp = 0
      DoEvents
    Wend
    frmMain.timWait.Enabled = False
           
    If intBufCnt = 5 And CheckCRC(3) = intInBuf(4) Then
      intByteArray(T1) = intInBuf(3)
      T1 = T1 + 1
      frmMain.pgbMain.Value = T1
    Else
      intErrors = intErrors + 1
      Call ShowErrorNum(intErrors)
      If intErrors >= intMaxTolErrors Then
        Call Msg(Format(intMaxTolErrors) & " Fehler berschritten.")
        Read_SBTC_EEPROM = 0
        Exit Do
      End If
    End If
    If intAbortStatus = 1 Then
      Exit Do
    End If
  Loop
  frmMain.pgbMain.Value = 0
    
  Open App.Path & "\" & strFileName For Output As #1
  For T2 = intByte0 To T1
    Print #1, Format(intByteArray(T2))
  Next T2
  Close #1
  
  Call ShowTransfer(0)
  intIsTransfer = 0
  Call MenuEnable(1)
  
  Call Msg(Format(T1 - intByte0) & " Zeichen empfangen.")
  Read_SBTC_EEPROM = T1 - intByte0
  Call ShowErrorNum(0)
  
End Function
Function SetSBTCByte%(intByteAdr%, intVal%)

  Dim intLoAdr%, intHiAdr%
  Dim strS$, T1%
  Dim intCRC%
      
  'Puffer initialisieren
  Call InitInBuffer
  intErrors = 0
    
  intHiAdr = Int(intByteAdr / 256)
  intLoAdr = intByteAdr - intHiAdr * 256
  
  intCRC = 0
  intCRC = intCRC Xor 101
  intCRC = intCRC Xor intLoAdr
  intCRC = intCRC Xor intHiAdr
  intCRC = intCRC Xor intVal
  
  strSendCode = Chr(101) & Chr(intLoAdr) & Chr(intHiAdr) & Chr(intVal) & Chr(intCRC)
  frmMain.comSBTC.Output = strSendCode
    
  'Flag auf 0 und Timer starten
  intTimeUp = 0
  frmMain.timWait.Enabled = True
  While intTimeUp = 0
    DoEvents
  Wend
  frmMain.timWait.Enabled = False
  
  If intBufCnt <> 4 Then
    intErrors = intErrors + 1
    frmMain.lblErrorCnt.Caption = Format(intErrors)
    SetSBTCByte = 0
    Exit Function
  End If
  
  'Vergleichen
  strS = ""
  For T1 = 0 To intBufCnt
    strS = strS & Chr(intInBuf(T1))
  Next T1
  
  If Left$(strS, 4) <> Left$(strSendCode, 4) Then
    intErrors = intErrors + 1
    frmMain.lblErrorCnt.Caption = Format(intErrors)
    SetSBTCByte = 0
    Exit Function
  End If
  
  SetSBTCByte = 1
  
  intTimeUp = 0
  frmMain.timWait.Enabled = True
  While intTimeUp = 0
  Wend
  frmMain.timWait.Enabled = False
     
End Function
Sub SetSBTCWord(intByteAdr%, intVal%)

  Dim intLoAdr%, intHiAdr%
  Dim intLoVal%, intHiVal%
  
  intHiAdr = Int(intByteAdr / 256)
  intLoAdr = intByteAdr - intHiAdr * 256
  intHiVal = Int(intVal / 256)
  intLoVal = intVal - intHiVal * 256
  
  Call SetSBTCByte(intLoAdr, intLoVal)
    
  intHiAdr = intByteAdr + 1
  intHiVal = Int(intVal / 256)
    
  Call SetSBTCByte(intHiAdr, intHiVal)
    
End Sub

Sub ShowErrorNum(intErrNum%)
  
  frmMain.lblErrorCnt.Caption = Format(intErrNum)
  
End Sub

Sub ShowTransfer(intMode%)

  Select Case intMode
    Case 0: frmMain.timDownload.Enabled = False
            frmMain.timUpload.Enabled = False
            intPicNum = 0
            frmMain.picCom.Picture = LoadPicture(App.Path & "\transfer" & Format(intPicNum) & ".bmp")
            frmMain.picCom.Refresh
    Case 1: intPicNum = 0
            frmMain.timDownload.Enabled = True
    Case 2: intPicNum = 13
            frmMain.timUpload.Enabled = True
  End Select
  
End Sub

Sub MenuEnable(intState%)

  If intState = 1 Then
    frmMain.mnuFile.Enabled = True
    frmMain.mnuSBTCRead.Enabled = True
    frmMain.mnuSBTCWrite.Enabled = True
    frmMain.mnuExtras.Enabled = True
    frmMain.cmdGetByte.Enabled = True
    frmMain.cmdSetByte.Enabled = True
  Else
    frmMain.mnuFile.Enabled = False
    frmMain.mnuSBTCRead.Enabled = False
    frmMain.mnuSBTCWrite.Enabled = False
    frmMain.mnuExtras.Enabled = False
    frmMain.cmdGetByte.Enabled = False
    frmMain.cmdSetByte.Enabled = False
  End If
    
End Sub
